@echo OFF
if not "%OS%"=="Windows_NT" goto WRONGOS
if not "%CD%"=="%~dp0" (
	%~d0
	cd "%~p0"
)
cls
:: common error
if exist BootDisk.exe.exe ren BootDisk.exe.exe BootDisk.exe
if not exist BootDisk.exe goto NO_BD
for %%f IN (burncdcc.exe extract.exe mkisofs.exe splitter.exe) DO set FILE=%%f&if not exist %%f goto NOFILE
set FILE=
if not exist E:\nul (
	set DRV=C
	goto DIRS
)
echo.
echo Some folders will be created for the files that will be
echo written to the bootable Recovery Console CD. Select the
echo hard drive where you would like to place these folders.
echo.
echo If the drive letter for your CD/DVD drive appears in
echo the list that follows, you CANNOT select that letter.
echo.
for %%d IN (C D E F G) DO call :DRVLIST %%d

:GETDRV
set DRV=
echo.
echo Type the drive letter and press ENTER
set /P DRV=or just press ENTER to quit: 
if "%DRV%"=="" goto DONE
echo %LIST% | find /I "%DRV:~0,1%" > NUL
if ERRORLEVEL 1 goto ERR
set DRV=%DRV:~0,1%
goto DIRS

:ERR
echo.
echo Drive %DRV:~0,1% is not a valid choice.
goto GETDRV

:DIRS
%DRV%:
cd \
set DRV=%CD:~0,1%
set DIR=RecoveryCD
if exist RecoveryCD\nul for /L %%f IN (9,-1,1) DO if not exist RecoveryCD.%%f\nul set DIR=RecoveryCD.%%f
md %DIR%\TMP
if ERRORLEVEL 1 goto NOACCESS
md %DIR%\I386\System32
echo.
echo Please click "Yes" in the End User License
echo Agreement (EULA) dialog that follows.
echo.
pause
cd %DIR%\I386
copy "%~dp0extract.exe"
"%~dp0BootDisk.exe" /C /T:%CD%
if not exist cdboot1.img (
	echo.
	echo You didn't select "Yes."
	echo.
	echo Press any key to exit . . .
	pause > NUL
	cd \
	rd %DIR% /S /Q
	goto DONE
)
extract -x cdboot?.img
cd ..
del I386\disk10? I386\*.exe I386\*.img
if exist %WINDIR%\System32\chkdsk.exe (
	copy %WINDIR%\System32\autochk.exe I386\ > NUL
	copy %WINDIR%\System32\autofmt.exe I386\ > NUL
	copy %WINDIR%\System32\chkdsk.exe I386\ > NUL
)
set XPL=P
expand -r I386\TXTSETUP.SI_ TMP\ > NUL
find "gpedit.msc" TMP\TXTSETUP.SIF > NUL
if ERRORLEVEL 1 set XPL=C
:: SP2 08/03/2004
:: SP1 08/29/2002
:: SP0 10/05/2001
set NUM=0
find "driver.cab,sp2.cab" TMP\TXTSETUP.SIF > NUL
if not ERRORLEVEL 1 (
	set NUM=2
	) else (
	find "driver.cab,sp1.cab" TMP\TXTSETUP.SIF > NUL
	if not ERRORLEVEL 1 set NUM=1
)
del TMP\TXTSETUP.SIF
echo Windows > WIN51
echo Windows > WIN51I%XPL%
if not "%NUM%"=="0" echo.> WIN51I%XPL%.SP%NUM%
set NUM=
"%~dp0splitter" I386\spcmdcon.sys TMP /SIZE84224 /SILENT
ren TMP\spcmdcon.sys.002 spcmdcon.sys
del TMP\*.00? TMP\spcmdcon.sys.h001
"%~dp0splitter" TMP\spcmdcon.sys TMP /SIZE2048 /SILENT
move TMP\spcmdcon.sys.001 xpboot.ima
rd TMP /S /Q
copy xpboot.ima "%~dp0" > NUL
set ASK=
cls
echo.
echo Would you like to burn the Recovery Console CD now?
echo.
echo Type "y" (without the quotes) for yes and press ENTER
set /P ASK=or just press ENTER to quit: 
if /I not "%ASK:~0,1%"=="Y" goto SUMMARY
echo.
echo NOTE: If two lines like the following appear:
echo.
echo "Warning: Creating ISO-9660:1999..."
echo "Warning: ISO-9660 filenames longer..."
echo.
echo You can ignore them. Starting mkisofs...
echo.
if "%XPL%"=="P" (
	set VOL=VRMPFPP_EN
	) else (
	set VOL=VRMHFPP_EN
)
"%~dp0mkisofs.exe" -iso-level 4 -volid "%VOL%" -b xpboot.ima -no-emul-boot -boot-load-size 4 -force-uppercase -hide xpboot.ima -hide boot.catalog -o "%~dp0XPRC.iso" "%DRV%:\%DIR%"
set VOL=
set XPL=
del xpboot.ima
echo.
echo Wait until BurnCDCC appears before inserting a blank
echo disk. After clicking on the "Start" gadget, you will
echo be prompted to insert one.
echo.
echo If you would rather burn a CD later on, simply click on
echo the "Close" gadget and the location of the ISO file will
echo be displayed.
echo.
pause
"%~dp0burncdcc" /I="%~dp0XPRC.iso" /F /V
echo.
echo If you need to burn an additional CD,
echo the ISO file is located here:
echo.
echo     %~dp0XPRC.iso
echo.
echo Press any key to exit . . .
pause > NUL
cd \
rd %DIR% /S /Q
goto DONE

:SUMMARY
del xpboot.ima
echo.
echo The Recovery Console CD files are located in:
echo.
echo     %DRV%:\%DIR%
echo.
echo The boot loader is located here:
echo.
echo     %~dp0xpboot.ima
echo.
echo Press any key to exit . . .
pause > NUL
goto DONE

:NO_BD
echo Can't find the file: BootDisk.exe
echo.
echo Copy the file downloaded from Microsoft to the directory
echo where this "bat" file is located (%~dp0).
echo.
echo Rename the file "BootDisk.exe" (without the quotes).
echo.
echo Press any key to exit . . .
pause > NUL
goto DONE

:NOFILE
echo.
echo Can't find the file: %FILE%
echo.
echo Make sure it has been copied to
echo the same folder as RecoveryCD.bat.
set FILE=
echo.
echo Press any key to exit . . .
pause > NUL
goto DONE

:WRONGOS
echo.
echo Windows 2000, XP or Server 2003 is required.
echo.
echo Press any key to exit . . .
pause > NUL
goto DONE

:NOACCESS
echo.
echo Error creating folder on drive %DRV%
echo.
echo Press any key to exit . . .
pause > NUL
goto DONE

:DONE
set ASK=
set DIR=
set DRV=
set LIST=
%~d0
cd %~p0
exit /B

:DRVLIST
if exist %1:\nul (
	echo      Drive %1
	set LIST=%LIST%%1
)
